include SchedLab.inc
include ../CmnHdr.inc
;**********************CODE SEGMENT*********************************
.code
start:
	invoke GetModuleHandle, NULL
	mov     hInstance,eax
	invoke InitCommonControls
	invoke CreateDialogParam,hInstance,IDD_SCHEDLAB,NULL,addr DlgProc,NULL
	mov hwnd,eax
	.while !fQuit
		invoke PeekMessage,addr msg,NULL,0,0,PM_REMOVE
		.if EAX
			;IsDialogMessage allows keyboard navigation to work 
			;properly.
			invoke IsDialogMessage,hwnd,addr msg
			.if eax==0
				mov eax,msg.message
				.if eax== WM_QUIT
					mov fQuit,TRUE;For WM_QUIT, terminate the loop.
				.else
					;Not a WM_QUIT message. Translate it and dispatch 
					;it.
					invoke TranslateMessage,addr msg
					invoke DispatchMessage,addr msg
				.endif									
			.endif;;if (!IsDialogMessage())			
		.else
			
			;Add a number to the listbox
			inc s_n
			invoke wsprintf,addr sz, SADD("%u"), s_n						
			invoke GetDlgItem,hwnd, IDC_WORK
			mov hwndWork,eax
			invoke SendMessage,eax,LB_ADDSTRING,0,addr sz
			invoke SendMessage,hwndWork,LB_SETCURSEL,eax,0
			
			;Remove some strings if there are too many entries
			invoke SendMessage,hwndWork,LB_GETCOUNT,0,0
			.while eax >100
				invoke SendMessage,hwndWork,LB_DELETESTRING,0,0
				invoke SendMessage,hwndWork,LB_GETCOUNT,0,0
			.endw
			
			;How long should the thread sleep
			invoke GetDlgItemInt,hwnd, IDC_SLEEPTIME, NULL, FALSE
			.if eax >1 && eax < 9999
				invoke Sleep,eax
			.endif						 
		.endif
	.endw
	invoke DestroyWindow,hwnd
	invoke ExitProcess,eax
;***********Thread Function**************************************
ThreadFunc proc hThreadPrimary:dword
	invoke SuspendThread,hThreadPrimary
	chMB SADD("The Primary thread is suspended.\nIt no longer responds to input and produces no output.\nPress OK to resume the primary thread & exit this secondary thread.\n")
	invoke ResumeThread,hThreadPrimary
	invoke CloseHandle,hThreadPrimary
	
	; To avoid deadlock, call EnableWindow after ResumeThread.
	invoke FindWindow,NULL, SADD("Scheduling Lab")
	INVOKE GetDlgItem,eax,IDC_SUSPEND
	invoke EnableWindow ,eax,TRUE

	XOR EAX,EAX
	ret
ThreadFunc endp
;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc  proc hWnd:HWND, uMsg:DWORD, wParam:WPARAM,lParam:LPARAM
local hwndCtrl:dword
local dwpc:dword
local nNormal:dword
local hThreadPrimary:dword
local dwThreadID:dword
	mov eax,uMsg
	.IF eax==WM_CLOSE
		INVOKE PostQuitMessage,NULL
	.elseif eax==WM_INITDIALOG
		invoke LoadIcon,hInstance,IDI_SCHEDLAB
		push eax
		invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax		
		pop eax
		invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
		
		; Initialize process priority classes
		invoke GetDlgItem,hWnd, IDC_PROCESSPRIORITYCLASS
		mov hwndCtrl,eax
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("High")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,HIGH_PRIORITY_CLASS

		;Save our current priority class
		invoke GetCurrentProcess
		invoke GetPriorityClass,eax
		mov dwpc,eax
		
		invoke GetCurrentProcess 
		invoke SetPriorityClass,eax,BELOW_NORMAL_PRIORITY_CLASS
		.if eax
			;This system supports the BELOW_NORMAL_PRIORITY_CLASS class
			
			;Restore our original priority class
			invoke GetCurrentProcess
			invoke SetPriorityClass,eax,dwpc
			
			;Add the Above Normal priority class
			invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Above normal")
			invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,ABOVE_NORMAL_PRIORITY_CLASS
			
			push 0
			pop dwpc;Remember that this system supports below normal
		.endif
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Normal")
		mov nNormal,eax
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,NORMAL_PRIORITY_CLASS

		.if dwpc == 0
			;This system supports the BELOW_NORMAL_PRIORITY_CLASS class
			
			;Add the Below Normal priority class		
				invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Below normal")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,BELOW_NORMAL_PRIORITY_CLASS
		.endif
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Idle")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,IDLE_PRIORITY_CLASS		
		invoke SendMessage,hwndCtrl,CB_SETCURSEL,nNormal,0
		
		;Initialize thread relative priorities
		invoke GetDlgItem,hWnd, IDC_THREADRELATIVEPRIORITY
		mov hwndCtrl,eax
		
		invoke SendMessage,eax,CB_ADDSTRING,0,SADD("Time critical")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,THREAD_PRIORITY_TIME_CRITICAL
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Highest")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,THREAD_PRIORITY_HIGHEST
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Above normal")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,THREAD_PRIORITY_ABOVE_NORMAL
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Normal")
		mov nNormal,eax
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,THREAD_PRIORITY_NORMAL
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Below normal")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,THREAD_PRIORITY_BELOW_NORMAL
		
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Lowest")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax, THREAD_PRIORITY_LOWEST
		invoke SendMessage,hwndCtrl,CB_ADDSTRING,0,SADD("Idle")
		invoke SendMessage,hwndCtrl,CB_SETITEMDATA,eax,THREAD_PRIORITY_IDLE
		
		invoke SendMessage,hwndCtrl,CB_SETCURSEL,nNormal,0
		
		invoke GetDlgItem,hWnd,IDC_SLEEPTIME
		invoke SendMessage,eax,EM_LIMITTEXT,4,0;Maximum of 9999
			
	.elseif	 eax== WM_COMMAND
		mov	eax,wParam
		and eax,0ffffh
		.IF EAX==IDCANCEL
			INVOKE PostQuitMessage,NULL
		.elseif eax ==IDC_PROCESSPRIORITYCLASS
			mov eax,wParam
			shr eax,16
			.if eax == CBN_SELCHANGE							
				invoke SendMessage,lParam,CB_GETCURSEL,0,0
				INVOKE SendMessage,lParam,CB_GETITEMDATA,eax,0
				push eax
				invoke GetCurrentProcess
				pop ecx
				invoke SetPriorityClass,eax,ecx	
			.endif					
		.elseif eax == IDC_THREADRELATIVEPRIORITY
			mov eax,wParam
			shr eax,16
			.if eax == CBN_SELCHANGE
				invoke SendMessage,lParam,CB_GETCURSEL,0,0
				INVOKE SendMessage,lParam,CB_GETITEMDATA,eax,0
				push eax
				invoke GetCurrentThread
				pop ecx
				invoke SetPriorityClass,eax,ecx	
			.endif
		.elseif eax == IDC_SUSPEND	
			; To avoid deadlock, call EnableWindow before creating
            ; the thread which calls SuspendThread.            
			invoke EnableWindow,lParam, FALSE
            
            invoke GetCurrentProcess
            mov dwpc,eax
            invoke GetCurrentThread
			mov dwThreadID,eax
            invoke DuplicateHandle,dwpc,dwThreadID,dwpc,addr hThreadPrimary, THREAD_SUSPEND_RESUME, FALSE, DUPLICATE_SAME_ACCESS
			invoke CreateThread,NULL, 0,offset ThreadFunc, 
            hThreadPrimary, 0,addr dwThreadID
            invoke CloseHandle,eax
		.endif
	.else
		mov	eax,FALSE
		ret
	.endif		   
	mov	eax,TRUE
	ret
DlgProc endp

end start
